import React from 'react';
import { BrowserRouterProps } from 'react-router-dom';
import { BaseRoutingContext, RoutingContext } from './utils';
export declare type NamedRouteConfig<T = object> = T & {
    name?: string;
    path?: string;
    title?: string;
    routes?: NamedRouteConfig<T>[];
};
export declare type NamedRouterProps<TRouterProps = BrowserRouterProps> = TRouterProps & {
    routes: NamedRouteConfig[];
    routerComponent?: React.ComponentType<TRouterProps>;
    routerProps?: TRouterProps;
    children?: React.ReactNode;
};
export declare const routerContext: React.Context<BaseRoutingContext | RoutingContext>;
export declare const useNamedRouting: () => BaseRoutingContext | RoutingContext;
declare const NamedRouter: ({ routerComponent: RouterComponent, routerProps, routes, children, }: NamedRouterProps<BrowserRouterProps>) => JSX.Element;
export default NamedRouter;
