"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_router_1 = require("react-router");
const tiny_invariant_1 = __importDefault(require("tiny-invariant"));
const NamedRouter_1 = require("./NamedRouter");
const NamedSwitch = ({ location: locationFromProps, children }) => {
    const context = NamedRouter_1.useNamedRouting();
    tiny_invariant_1.default(context, 'You should not use <NamedSwitch> outside a <NamedRouter>');
    const location = locationFromProps || context.location;
    let element = null;
    let match = null;
    react_1.default.Children.forEach(children, (child) => {
        if (match === null && react_1.default.isValidElement(child)) {
            element = child;
            const path = child.props.name ? context.getRawPath(child.props.name) : child.props.from;
            match = react_router_1.matchPath(location.pathname, Object.assign({}, child.props, { path }));
        }
    });
    return match && element
        ? react_1.default.cloneElement(element, { location, computedMatch: match })
        : null;
};
exports.default = NamedSwitch;
